-- | Este es un modulo de proposito general donde deben almacenarse algoritmos famosos
-- pensando en facilitar su uso fuera del proyecto actual.
module Algoritmos where

-- | Algoritmo de vuelta atras.
vueltaAtras :: 
	(a->Bool) 	-- ^ valido nodo: True sii nodo es solucion
	-> (a->[a]) 	-- ^ hijos nodo
	-> (a->Bool) 	-- ^ condicionesDePoda nodo: False sii debe podarse rama
	-> a 		-- ^ ensayo: nodo inicial
	-> [a]		-- ^ salida: lista de nodos validos

-- | Algoritmo voraz. No se ha fijado una implementacion para los conjuntos, por lo que
-- deben darse las funciones \"excepto\", \"con\" y \"vacio\", siguiendo las
-- definiciones dadas (c es un conjunto, y e es un elemento).
voraz :: Eq c => 
	(c->e->c) 		-- ^ c \`excepto\` e = c - {e} 	(diferencia)
	-> (c->e->c)		-- ^ c \`con\` e = c U {e}	(union)
	-> c			-- ^ vacio = {}
	-> (c->Bool) 		-- ^ solucion c: True sii c es solucion
	-> (c->e) 		-- ^ seleccionar c: elemento que se incorpora a posible solucion
	-> (c->Bool) 		-- ^ completable c: False si ningun subconjunto es solucion
	-> c 			-- ^ conjunto inicial
	-> c			-- ^ salida: conjunto devuelto


vueltaAtras valido hijos condicionesDePoda ensayo
	| valido ensayo = [ensayo]
	| otherwise 	= [nodo| hijo<-hijos ensayo, condicionesDePoda hijo, nodo<-vA hijo]
	where
	vA = vueltaAtras valido hijos condicionesDePoda


voraz  excepto con vacio  solucion seleccionar completable c = ivoraz c vacio
	where
	ivoraz c s
		| c==vacio	|| solucion s	= s
		| completable (s`con`e)		= ivoraz (c`excepto`e) (s`con`e)
		| otherwise			= ivoraz (c`excepto`e) s
		where
		e = seleccionar c
